<script setup>
import { computed, ref } from "vue";
import { useStore } from "vuex";

const store = useStore();
const serverlog = computed(() => store.state.serverLog.messages);
const isOpen = computed(() => store.state.serverLog.isOpen);
const filter = ref("");

const filtered = computed(() =>
  serverlog.value.filter((log) => {
    const f = filter.value.toLowerCase();
    if (!f) return true;
    else if (log.message.toLowerCase().includes(f)) return true;
    else if (log.topic.toLowerCase().includes(f)) return true;
    else if (log.level.toLowerCase().includes(f)) return true;
    else if (log.id.toString().toLowerCase().includes(f)) return true;
    else return false;
  }),
);
</script>

<template>
  <div v-if="isOpen" class="log-container">
    <nav class="level mb-1">
      <div class="level-left">
        <div class="level-item pl-1">
          <Icon :icon="'terminal'" :interactive="false" />
        </div>
        <div class="level-item">
          <p class="subtitle is-5">Console</p>
        </div>
      </div>
      <div class="level-right">
        <div class="level-item">
          <button class="button is-ghost" @click="$store.dispatch('serverLog/toggle')">
            <Icon class="has-text-dark" :icon="'x'" :tooltip="'Close Log'" />
          </button>
        </div>
      </div>
    </nav>

    <div class="field is-horizontal m-0">
      <div class="field-body">
        <div class="field">
          <div class="control">
            <div class="select" @change="(e) => $store.dispatch('serverLog/changeLogLevel', e.target.value)">
              <select>
                <option value="error">error</option>
                <option value="warn">warn</option>
                <option value="info" selected>info</option>
                <option value="debug">debug</option>
                <option value="trace">trace</option>
              </select>
            </div>
          </div>
        </div>
        <div class="field has-addons">
          <p class="control is-expanded">
            <input v-model="filter" type="text" class="input" placeholder="Filter Log" @change="filterData" />
          </p>
          <p class="control">
            <button class="button">
              <Icon :icon="'delete'" :tooltip="'clear input'" @click="filter = ''" />
            </button>
          </p>
        </div>
      </div>
    </div>

    <div class="is-flex-grow-1 p-2 is-scroll-container has-background-black has-text-light is-family-monospace">
      <p
        v-for="log in filtered.slice().reverse()"
        :key="log.id"
        class="is-selectable pb-2"
        :style="{ 'line-height': 1, 'user-select': 'text'}"
      >
        {{ log.id }}
        <span
          :class="{
            'has-text-danger': log.level == 'error',
            'has-text-warning': log.level == 'warn',
            'has-text-adaptor': log.level == 'info',
            'has-text-success': log.level == 'debug',
            'has-text-info': log.level == 'trace',
          }"
        >
          {{ log.level }}&nbsp;
        </span>
        <span class="has-text-adaptor">{{ log.topic }}</span>
        <br />
        {{ log.message }}
      </p>
    </div>
  </div>
</template>
